# Download the SAST reports (if required)

. $dir_base/gitlab-api.sh
cache_pipelines="$dir_runs/pipelines.json.gz"
cache_pipelines_ttl=15 # Time (in minutes) we prioritise our local version (if present) over the source-of-truth

# Prune the files generated by a partial download attempt
function abort_download() {
    if [ ! -z "$dir_run" ] && [ -e "$dir_run" ]
    then
        rm -rf $dir_run
    fi
}

# Determine from the source-of-truth, any pipeline runs we are missing, and then download their artifacts
function identify_pipeline_catchup() {
    download_pipeline_runs
    for pipeline in $(zcat $cache_pipelines | jq -r '.[] | "I:\(.id);D:\(.created_at);B:\(.ref)"' | grep -Fv 'B:master')
    do
        dir_test=$(echo "$pipeline" | sed -r 's/^I:([0-9]+);D:(20[0-9]{2}-[0-9]{2}-[0-9]{2})T.+$/\2_\1/')
        # We do not need to continue if we have found a pipeline we have previously loaded
        [ -e "$dir_runs/$dir_test" ] && return
        pipeline_id=$(echo "$pipeline" | awk -F';' '{ print $1 }' | grep -Po '[0-9]+$')
        pipeline_date=$(echo "$pipeline" | awk -F';' '{ print $2 }' | grep -Po '20[0-9]{2}-[0-9]{2}-[0-9]{2}')
        dir_run="$dir_runs/$dir_test"
        display_info "Downloading artifacts from pipeline $pipeline_id ($pipeline_date)"
        download_pipeline_artifacts
    done
    echo
    # Reset our internal trackers
    pipeline_id=
    dir_run=
}

# Determine from the source-of-truth, the ID of the latest pipeline run
function identify_pipeline_latest() {
    download_pipeline_runs
    pipeline=$(zcat $cache_pipelines | jq -r '.[] | "I:\(.id);D:\(.created_at);B:\(.ref)"' | grep -Fv 'B:master' | head -1)
    pipeline_id=$(echo "$pipeline" | awk -F';' '{ print $1 }' | grep -Po '[0-9]+$')
    if [ -z "$pipeline_id" ]
    then
        display_error "Unable to determine the ID of the last successful non-master pipeline" >&2
        exit 1
    fi
    pipeline_date=$(echo "$pipeline" | awk -F';' '{ print $2 }' | grep -Po '20[0-9]{2}-[0-9]{2}-[0-9]{2}')
    dir_run="$dir_runs/${pipeline_date}_${pipeline_id}"
}

# Worker method for downloading, if no sufficient cache version exists, the list of recent pipeline runs
function download_pipeline_runs() {
    # If we have a recent on-disk file present, use that instead of re-requesting the info from the API
    if [ ! -e $cache_pipelines ] || [ -z $(find $cache_pipelines -type f -mmin -$cache_pipelines_ttl) ]
    then
        [ -e $cache_pipelines ] && rm $cache_pipelines # Our API downloader does not explicitly over-write existing files
        pipelines=$(call_gitlab_api '/pipelines?scope=finished&status=success' "$cache_pipelines")
    fi
}

# Ensure the artifacts for the requested pipeline have been downloaded
function download_pipeline_artifacts() {
    # Create our local store, if it doesn't already exist
    [ ! -e $dir_run ] && mkdir -p $dir_run

    # Get detail of jobs within that pipeline to identify their security jobs
    file_jobs="$dir_run/jobs.json.gz"
    call_gitlab_api "/pipelines/$pipeline_id/jobs?scope=success" "$file_jobs"
    for job in $(zcat $file_jobs | jq -r '.[] | "I:\(.id);N:\(.name);S:\(.stage)"' | grep -F 'S:security' | grep -Pv 'N:(php|js)_security')
    do
        # Get the job info we'll use on the download
        job_id=$(echo "$job" | awk -F ';' '{ print $1 }' | grep -Po '[0-9]+$')
        job_name=$(echo "$job" | awk -F ';' '{ print $2 }' | sed 's/^N://')
        # Download the SAST report
        call_gitlab_api "/jobs/$job_id/artifacts?file_type=sast" "$dir_run/$job_name.json.gz"
    done
}
